/*
 * Хꥺɽե
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_draw.c,v 1.1 2000/05/29 00:07:37 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#include "brthm.h"

static gdouble		Wbrd_psi_table[3][WBR_CYCLE_INTEL * WBR_INTERVAL];
											// Ρ
static GtkWidget	*Wbrd_darea;			// 襨ꥢ
static GdkPixmap	*Wbrd_pixmap = NULL;	// 襨ꥢ
static GdkGC		*Wbrd_gc_color[5] = {	// ɽ
						NULL, NULL, NULL, NULL, NULL
					};
static GdkFont		*Wbrd_font = NULL;		// ե
static GdkFont		*Wbrd_kfont = NULL;		// ܸե

static gint			wbrd_cb_darea_expose(GtkWidget *, GdkEventExpose *);
static gint			wbrd_cb_darea_config(GtkWidget *,
										GdkEventConfigure *);
static void			wbrd_create_gc(GtkWidget *);
static void			wbrd_draw_baseitem(gint, gint);
static void			wbrd_draw_brthm(gint, gint, gint, gint, time_t);

/*===============
 *   ̾ : wbr_init_psi_table()
 *     ǽ : Уӣɥơ֥ν
 *    : ʤ
 */
void				wbr_init_psi_table(void)
{
	gint			loop_cnt;			// 롼ץ
	gint			loop_num;			// 롼ײ
	gdouble			stand_value;		// 

	stand_value = (M_PI * 2) / (WBR_CYCLE_PHYS * WBR_INTERVAL);
	loop_num = WBR_CYCLE_PHYS * WBR_INTERVAL;
	for (loop_cnt = 0; loop_cnt < loop_num; loop_cnt++) {
		Wbrd_psi_table[0][loop_cnt] = sin(loop_cnt * stand_value);
	}

	stand_value = (M_PI * 2) / (WBR_CYCLE_SENS * WBR_INTERVAL);
	loop_num = WBR_CYCLE_SENS * WBR_INTERVAL;
	for (loop_cnt = 0; loop_cnt < loop_num; loop_cnt++) {
		Wbrd_psi_table[1][loop_cnt] = sin(loop_cnt * stand_value);
	}

	stand_value = (M_PI * 2) / (WBR_CYCLE_INTEL * WBR_INTERVAL);
	loop_num = WBR_CYCLE_INTEL * WBR_INTERVAL;
	for (loop_cnt = 0; loop_cnt < loop_num; loop_cnt++) {
		Wbrd_psi_table[2][loop_cnt] = sin(loop_cnt * stand_value);
	}
}

/*===============
 *   ̾ : wbr_draw_brthm()
 *     ǽ : Хꥺ(ƽ)
 *    : ʤ
 */
void				wbr_draw_brthm(void)
{
	gint			pos_x;				// ɽ
	gint			pos_y;				// ɽ
	gint			width;				// 襨ꥢ
	gint			height;				// 襨ꥢ⤵
	gint			loop_cnt;			// 롼ץ
	gint			disp_num;			// ɽ
	
	width = (gint)wbr_get_param(WBR_PRM_ID_GRAPHWIDTH);
	height = (gint)wbr_get_param(WBR_PRM_ID_GRAPHHEIGHT);

	if ((width > 0) && (height > 0)) {
		gdk_draw_rectangle(Wbrd_pixmap,
							Wbrd_gc_color[1],
							TRUE,
							0, 0,
							width, height);

		wbrd_draw_baseitem(width, height);
		disp_num = (gint)wbr_get_user_info(WBR_PRM_ID_BIRTHNUM, 0);
		pos_x = 0;
		pos_y = 0;
		height = height / disp_num;

		for (loop_cnt = 0; loop_cnt < disp_num; loop_cnt++) {
			wbrd_draw_brthm(pos_x, pos_y, width, height,
				(time_t)wbr_get_user_info(WBR_PRM_ID_BIRTHDAY,
													loop_cnt));
			pos_y += height;
		}

		gdk_draw_pixmap(Wbrd_darea->window,
				Wbrd_darea->style->fg_gc[GTK_WIDGET_STATE(Wbrd_darea)],
				Wbrd_pixmap,
				0, 0,
				0, 0,
				width, height);
	}
}

/*===============
 *   ̾ : wbr_create_draw_area()
 *     ǽ : 襨ꥢ
 *    : 襨ꥢ
 */
GtkWidget			*wbr_create_draw_area(
GtkWidget			*parent				// (I) ƥå
)
{
	GtkWidget		*draw_vbox;			// 襨ꥢܥå

	draw_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(parent), draw_vbox);
	Wbrd_darea = gtk_drawing_area_new();
	gtk_drawing_area_size(GTK_DRAWING_AREA(Wbrd_darea), 100, 100);
	gtk_box_pack_start(GTK_BOX(draw_vbox), Wbrd_darea, TRUE, TRUE, 0);
	gtk_widget_show(draw_vbox);

	gtk_signal_connect(GTK_OBJECT(Wbrd_darea), "expose_event",
						(GtkSignalFunc)wbrd_cb_darea_expose, NULL);
	gtk_signal_connect(GTK_OBJECT(Wbrd_darea), "configure_event",
						(GtkSignalFunc)wbrd_cb_darea_config, NULL);

	return Wbrd_darea;
}

/*===============
 *   ̾ : wbrd_cb_darea_expose()
 *     ǽ : 襨ꥢ襳Хå
 *    : FALSE= ｪλ
 */
static gint			wbrd_cb_darea_expose(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventExpose		*event				// (I) ٥Ⱦ
)
{
	gdk_draw_pixmap(widget->window,
					widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
					Wbrd_pixmap,
					event->area.x, event->area.y,
					event->area.x, event->area.y,
					event->area.width, event->area.height);

	return FALSE;
}

/*===============
 *   ̾ : wbrd_cb_darea_config()
 *     ǽ : 襨ꥢꥢ饤Хå
 *    : TRUE= ｪλ
 */
static gint			wbrd_cb_darea_config(
GtkWidget			*widget,			// (I) 襨ꥢ
GdkEventConfigure	*event				// (I) ٥Ⱦ
)
{
	gint			win_size;			// 襨ꥢ⤵

	if (Wbrd_pixmap) {
		gdk_pixmap_unref(Wbrd_pixmap);
	}
	wbrd_create_gc(widget);

	win_size = widget->allocation.width;
	wbr_put_param(WBR_PRM_ID_GRAPHWIDTH, (void *)win_size);
	win_size = widget->allocation.height;
	wbr_put_param(WBR_PRM_ID_GRAPHHEIGHT, (void *)win_size);

	Wbrd_pixmap = gdk_pixmap_new(widget->window,
								widget->allocation.width,
								widget->allocation.height,
								-1);
	gdk_draw_rectangle(Wbrd_pixmap,
						Wbrd_gc_color[1],
						TRUE,
						0, 0,
						widget->allocation.width,
						widget->allocation.height);
	wbr_draw_brthm();

	return TRUE;
}

/*===============
 *   ̾ : wbr_create_gc()
 *     ǽ : եåƥȤκ
 *    : ʤ
 */
static void			wbrd_create_gc(
GtkWidget			*widget				// (I) 襨ꥢ
)
{
	gint			loop_cnt;			// 롼ץ
	gint			param_value;		// ѥ᡼ɣ
	GdkColormap		*cmap;				// 
	GdkColor		*temp_color;		// ѿ

	cmap = gdk_colormap_get_system();

	param_value = WBR_PRM_ID_GRAPHFORE;
	for (loop_cnt = 0; loop_cnt < 5; loop_cnt++) {
		if (!Wbrd_gc_color[loop_cnt]) {
			Wbrd_gc_color[loop_cnt] = gdk_gc_new(widget->window);
			temp_color = wbr_get_param(param_value);
			gdk_color_alloc(cmap, temp_color);
			gdk_gc_set_foreground(Wbrd_gc_color[loop_cnt], temp_color);
		}
		param_value++;

		gdk_gc_set_line_attributes(Wbrd_gc_color[loop_cnt],
				(gint)wbr_get_param(WBR_PRM_ID_LINEWIDTH),
				GDK_LINE_SOLID,
				GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	}

	if (!Wbrd_font) {
		Wbrd_font = gdk_fontset_load("6x12");
	}
	if (!Wbrd_kfont) {
		Wbrd_kfont = gdk_fontset_load("k12");
	}
}

/*===============
 *   ̾ : wbrd_draw_baseitem()
 *     ǽ : ʤɤ
 *    : ʤ
 */
static void			wbrd_draw_baseitem(
gint				width,				// (I) 
gint				height				// (I) ⤵
)
{
	gchar			*psi_str[] = {		// Уӣʸ
						NULL, NULL, "", "", ""
					};
	gint			loop_cnt;			// 롼ץ
	gint			pos_x;				// 
	gint			pos_y;				// 
	gchar			draw_str[20];		// ʸ
	gint			obj_width;			// ޤΥ
	gint			obj_height;			// ޤΥ
	gint			one_day;			// ÿ
	time_t			disp_day;			// ɽ
	gint			period_days;		// ɽ

	obj_height = gdk_text_height(Wbrd_kfont,
					draw_str, strlen(draw_str)) - 2;
	obj_width = obj_height;

	// 
	strcpy(draw_str, "");
	pos_x = (width - 10)
			- gdk_text_width(Wbrd_kfont, draw_str, strlen(draw_str));
	pos_y = gdk_text_height(Wbrd_kfont, draw_str, strlen(draw_str));
	gdk_draw_text(Wbrd_pixmap,
				Wbrd_kfont,
				Wbrd_gc_color[0],
				pos_x, pos_y,
				draw_str, strlen(draw_str));
	pos_x -= (obj_height + 2);
	gdk_draw_arc(Wbrd_pixmap,
				Wbrd_gc_color[0],
				FALSE,
				pos_x, pos_y - (obj_height),
				obj_height, obj_height,
				0, 360 * 64);

	for (loop_cnt = 4; loop_cnt >= 2; loop_cnt--) {
		pos_x -= gdk_text_width(Wbrd_kfont, draw_str,
								strlen(draw_str)) / 2;
		strcpy(draw_str, psi_str[loop_cnt]);
		pos_x -= gdk_text_width(Wbrd_kfont, draw_str, strlen(draw_str));
		gdk_draw_text(Wbrd_pixmap,
					Wbrd_kfont,
					Wbrd_gc_color[loop_cnt],
					pos_x, pos_y,
					draw_str, strlen(draw_str));
		pos_x -= (obj_width + 2);
		gdk_draw_rectangle(Wbrd_pixmap,
							Wbrd_gc_color[loop_cnt],
							TRUE,
							pos_x, pos_y - (obj_height - 1),
							obj_width, obj_height);
	}

	// 
	one_day = 24 * 60 * 60;
	disp_day = (time_t)wbr_get_param(WBR_PRM_ID_DISPDAY);
	disp_day = (gint)(disp_day / one_day) * one_day;
	strftime(draw_str, sizeof(draw_str),
			"%Y/%m/%d", localtime(&disp_day));
	pos_x = (width - gdk_text_width(Wbrd_font,
						draw_str, strlen(draw_str))) / 2;
	pos_y = height;
	gdk_draw_text(Wbrd_pixmap,
				Wbrd_font,
				Wbrd_gc_color[0],
				pos_x, pos_y,
				draw_str, strlen(draw_str));

	period_days = (gint)wbr_get_param(WBR_PRM_ID_DISPPERIOD) * one_day;
	disp_day -= period_days;
	strftime(draw_str, sizeof(draw_str),
			"%Y/%m/%d", localtime(&disp_day));
	pos_x = 10;
	gdk_draw_text(Wbrd_pixmap,
				Wbrd_font,
				Wbrd_gc_color[0],
				pos_x, pos_y,
				draw_str, strlen(draw_str));

	disp_day += (period_days * 2);
	strftime(draw_str, sizeof(draw_str),
			"%Y/%m/%d", localtime(&disp_day));
	pos_x = width - gdk_text_width(Wbrd_font,
						draw_str, strlen(draw_str)) - 10;
	gdk_draw_text(Wbrd_pixmap,
				Wbrd_font,
				Wbrd_gc_color[0],
				pos_x, pos_y,
				draw_str, strlen(draw_str));
}

/*===============
 *   ̾ : wbrd_draw_brthm()
 *     ǽ : Хꥺ
 *    : ʤ
 */
static void			wbrd_draw_brthm(
gint				pos_x,				// (I) 賫ϰ
gint				pos_y,				// (I) 賫ϰ
gint				width,				// (I) 
gint				height,				// (I) ⤵
time_t				birth_day			// (I) 
)
{
	gint			mrg_width;			// ޡ
	gint			mrg_height;			// ޡ⤵
	gint			disp_pnt;			// ɽ
	gint			disp_start;			// ɽ
	gint			disp_end;			// ɽλ
	gint			period_days;		// ɽ
	gint			show_me;			// ɽ롿ʤ
	gint			cycle[3];			// 
	gint			one_day;			// ÿ
	gint			now_pnt;			// ɽ
	gint			text_x;				// ɽ(ƥ)
	gint			text_y;				// ɽ(ƥ)
	gint			from_x = 0;			// ɽ
	gint			from_y = 0;			// ɽ
	gint			to_x;				// ɽ
	gint			to_y;				// ɽ
	gint			circle_size;		// ߤ礭
	gint			loop_cnt;			// 롼ץ
	gint			psi_cnt;			// 롼ץ
	gdouble			scale_x;			// غɸ
	gdouble			scale_y;			// ٺɸ
	gchar			after_birth[100];	// 
	gchar			draw_str[10];		// ʸ

	mrg_width = 15;
	mrg_height = 15;
	disp_pnt = (time_t)wbr_get_param(WBR_PRM_ID_DISPDAY) - birth_day;
	one_day = 24 * 60 * 60;
	disp_pnt = (gint)(disp_pnt / one_day) * one_day;
	period_days = (gint)wbr_get_param(WBR_PRM_ID_DISPPERIOD) * one_day;
	disp_start = disp_pnt - period_days;
	disp_end = disp_pnt + period_days;
	show_me = (gint)wbr_get_param(WBR_PRM_ID_GRAPHDISP);
	cycle[0] = WBR_CYCLE_PHYS * WBR_INTERVAL;
	cycle[1] = WBR_CYCLE_SENS * WBR_INTERVAL;
	cycle[2] = WBR_CYCLE_INTEL * WBR_INTERVAL;
	circle_size = (height - mrg_height * 2) * ((gdouble)2 / 100);
	circle_size = (circle_size < 5) ? 5 : circle_size;

	// 
	gdk_draw_line(Wbrd_pixmap,
				Wbrd_gc_color[0],
				pos_x + mrg_width, pos_y + mrg_height,
				pos_x + mrg_width, pos_y + height - mrg_height);
	gdk_draw_line(Wbrd_pixmap,
				Wbrd_gc_color[0],
				pos_x + (width / 2), pos_y + mrg_height,
				pos_x + (width / 2), pos_y + height - mrg_height);
	gdk_draw_line(Wbrd_pixmap,
				Wbrd_gc_color[0],
				pos_x + width - mrg_width, pos_y + mrg_height,
				pos_x + width - mrg_width, pos_y + height - mrg_height);
	gdk_draw_line(Wbrd_pixmap,
				Wbrd_gc_color[0],
				pos_x + mrg_width, pos_y + height / 2,
				pos_x + width - mrg_width, pos_y + height / 2);

	strcpy(draw_str, "");
	text_x = pos_x + mrg_width
			- gdk_text_width(Wbrd_kfont, draw_str, strlen(draw_str));
	text_y = pos_y + mrg_height + gdk_text_height(Wbrd_kfont,
						draw_str, strlen(draw_str));
	gdk_draw_text(Wbrd_pixmap,
				Wbrd_kfont,
				Wbrd_gc_color[0],
				text_x, text_y,
				draw_str, strlen(draw_str));
	strcpy(draw_str, "");
	text_y = pos_y + (height / 2);
	gdk_draw_text(Wbrd_pixmap,
				Wbrd_kfont,
				Wbrd_gc_color[0],
				text_x, text_y,
				draw_str, strlen(draw_str));
	strcpy(draw_str, "");
	text_y = pos_y + height - mrg_height;
	gdk_draw_text(Wbrd_pixmap,
				Wbrd_kfont,
				Wbrd_gc_color[0],
				text_x, text_y,
				draw_str, strlen(draw_str));

	// 
	if ((gboolean)wbr_get_param(WBR_PRM_ID_DISPTOTAL) == TRUE) {
		text_x = pos_x + gdk_text_width(Wbrd_kfont, "", 2) / 2;
		text_y = pos_y + gdk_text_height(Wbrd_kfont, "", 2);
		strcpy(after_birth, "");
		gdk_draw_text(Wbrd_pixmap,
					Wbrd_kfont,
					Wbrd_gc_color[0],
					text_x, text_y,
					after_birth, strlen(after_birth));
		text_x += gdk_text_width(Wbrd_kfont,
						after_birth, strlen(after_birth));
		sprintf(after_birth, " %d ", disp_pnt / one_day);
		gdk_draw_text(Wbrd_pixmap,
					Wbrd_font,
					Wbrd_gc_color[0],
					text_x, text_y,
					after_birth, strlen(after_birth));
		text_x += gdk_text_width(Wbrd_font,
						after_birth, strlen(after_birth));
		strcpy(after_birth, "");
		gdk_draw_text(Wbrd_pixmap,
					Wbrd_kfont,
					Wbrd_gc_color[0],
					text_x, text_y,
					after_birth, strlen(after_birth));
	}

	// դ
	disp_start = (disp_start / one_day);
	disp_end = (disp_end / one_day);
	if ((gboolean)wbr_get_param(WBR_PRM_ID_DAYLINE) == TRUE) {
		gdk_gc_set_line_attributes(Wbrd_gc_color[0],
					1,
					GDK_LINE_ON_OFF_DASH,
					GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
		if ((gboolean)wbr_get_param(WBR_PRM_ID_DAYLINE) == TRUE) {
			scale_x = (gdouble)(width - (mrg_width * 2))
									/ (disp_end - disp_start);
			scale_y = (gdouble)(height - (mrg_height * 2)) / 2;
			from_y = mrg_height + pos_y
					+ ((height - mrg_height * 2) * ((gdouble)98 / 100));
			to_y = height - mrg_height + pos_y
					- ((height - mrg_height * 2) * ((gdouble)98 / 100));
			for (loop_cnt = disp_start + 1;
				loop_cnt < disp_end; loop_cnt++) {
				from_x = mrg_width + scale_x
							* (loop_cnt - disp_start) + pos_x;
				to_x = from_x;
				gdk_draw_line(Wbrd_pixmap,
							Wbrd_gc_color[0],
							from_x, from_y,
							to_x, to_y);
			}
		}
		gdk_gc_set_line_attributes(Wbrd_gc_color[0],
					(gint)wbr_get_param(WBR_PRM_ID_LINEWIDTH),
					GDK_LINE_SOLID,
					GDK_CAP_NOT_LAST, GDK_JOIN_MITER);
	}

	// 
	disp_start = disp_start * WBR_INTERVAL;
	disp_end = disp_end * WBR_INTERVAL;
	scale_x = (gdouble)(width - (mrg_width * 2))
							/ (disp_end - disp_start);
	scale_y = (gdouble)(height - (mrg_height * 2)) / 2;
	if ((show_me & WBR_TYPE_WARN) != 0) {
		for (loop_cnt = disp_start;
			loop_cnt < disp_end; loop_cnt += WBR_INTERVAL) {
			to_y = mrg_height + pos_y;
			for (psi_cnt = 0; psi_cnt < 3; psi_cnt++) {
				now_pnt = loop_cnt % cycle[psi_cnt];
				while (now_pnt < 0) {
					now_pnt += cycle[psi_cnt];
				}
				if ((Wbrd_psi_table[psi_cnt][now_pnt] > -0.15) &&
					(Wbrd_psi_table[psi_cnt][now_pnt] < 0.15)) {
					to_x = mrg_width + scale_x
							* (loop_cnt - disp_start)
							+ pos_x - circle_size / 2;
					gdk_draw_arc(Wbrd_pixmap,
								Wbrd_gc_color[psi_cnt + 2],
								TRUE,
								to_x, to_y,
								circle_size, circle_size,
								0, 360 * 64);
					to_y += (circle_size * 1);
				}
			}
		}
	}

	// Хꥺ
	for (psi_cnt = 0; psi_cnt < 3; psi_cnt++) {
		if ((show_me & (1 << psi_cnt)) != 0) {
			for (loop_cnt = disp_start; loop_cnt <= disp_end;
				loop_cnt += (gint)wbr_get_param(WBR_PRM_ID_GRAPHPOINT)) {
				now_pnt = loop_cnt % cycle[psi_cnt];
				while (now_pnt < 0) {
					now_pnt += cycle[psi_cnt];
				}
				to_x = mrg_width + scale_x *
						(loop_cnt - disp_start) + pos_x;
				to_y = mrg_height + scale_y *
						(1 - Wbrd_psi_table[psi_cnt][now_pnt]) + pos_y;
				if (loop_cnt != disp_start) {
					gdk_draw_line(Wbrd_pixmap,
								Wbrd_gc_color[psi_cnt + 2],
								from_x, from_y,
								to_x, to_y);
				}
				from_x = to_x;
				from_y = to_y;
			}
		}
	}
}
