/*
 * Хꥺɽե
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_param.c,v 1.1 2000/05/29 00:07:37 tonton Exp $
 */

#include <sys/param.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "brthm.h"

#define		WBR_INIFILE		"brthm.ini"

#define		WBR_PRM_KEY_USERNAME		"username"
#define		WBR_PRM_KEY_BIRTHDAY		"birthday"
#define		WBR_PRM_KEY_DISPPERIOD		"dispperiod"
#define		WBR_PRM_KEY_BIRTHYEAR		"birthyear"
#define		WBR_PRM_KEY_DISPTOTAL		"disptotalday"
#define		WBR_PRM_KEY_CALENDAR		"calendar"

#define		WBR_PRM_KEY_GRAPHPOINT		"graphpoint"
#define		WBR_PRM_KEY_GRAPHWIDTH		"graphwidth"
#define		WBR_PRM_KEY_GRAPHHEIGHT		"graphheight"
#define		WBR_PRM_KEY_LINEWIDTH		"linewidth"
#define		WBR_PRM_KEY_GRAPHDISP		"graphdisp"
#define		WBR_PRM_KEY_DAYLINE			"dayline"
#define		WBR_PRM_KEY_GRAPHFORE		"graphfore"
#define		WBR_PRM_KEY_GRAPHBACK		"graphback"
#define		WBR_PRM_KEY_GRAPHPHYS		"graphphys"
#define		WBR_PRM_KEY_GRAPHSENS		"graphsens"
#define		WBR_PRM_KEY_GRAPHINTEL		"graphintel"

/* ǥե */
#define		WBRP_PRM_DEF_DISPPERIOD		15
#define		WBRP_PRM_DEF_CALENDAR		0
#define		WBRP_PRM_DEF_GRAPHPOINT		3
#define		WBRP_PRM_DEF_LINEWIDTH		2
#define		WBRP_PRM_DEF_GRAPHDISP		(1 | 2 | 4 | 8)
#define		WBRP_PRM_DEF_GRAPHFORE		{0, 0x0000, 0x0000, 0x0000}
#define		WBRP_PRM_DEF_GRAPHBACK		{0, 0xffff, 0xffff, 0xffff}
#define		WBRP_PRM_DEF_GRAPHPHYS		{0, 0x0000, 0x0000, 0xffff}
#define		WBRP_PRM_DEF_GRAPHSENS		{0, 0xffff, 0x0000, 0x0000}
#define		WBRP_PRM_DEF_GRAPHINTEL		{0, 0x0000, 0xffff, 0x0000}

typedef struct {
	gchar			**user_name;		// ̾
	time_t			*birthday;			// 
	gint			disp_period;		// ɽ
	gboolean		birth_year;			// ǯɽ
	gboolean		disp_total;			// ɽ
	gint			calendar;			// ɽ

	gint			graph_point;		// ɽ
	gint			graph_width;		// ɽ
	gint			graph_height;		// ɽ⤵
	gint			line_width;			// 
	gint			graph_disp;			// ɽ
	gboolean		day_line;			// ɽ
	GdkColor		graph_color[5];		// ʿطʿУӣ

	time_t			disp_day;			// ɽ
	gint			birth_num;			// ̾ǡ
} WBRP_PVALUE;
static WBRP_PVALUE	Wbrp_pvalue;		// ѥ᡼

static gboolean		wbrp_get_key_value(gchar *, gchar *, FILE *);
static void			wbrp_put_birthday(gchar *);
static void			wbrp_get_color(GdkColor *, gchar *);

/*===============
 *   ̾ : wbr_get_param()
 *     ǽ : ѥ᡼ͤμ
 *    : ѥ᡼
 */
void				*wbr_get_param(
gint				param_id			// (I) ѥ᡼ɣ
)
{
	void			*param_value = NULL;// ѥ᡼

	if (param_id == WBR_PRM_ID_DISPPERIOD) {
		param_value = (void *)Wbrp_pvalue.disp_period;
	}
	else if (param_id == WBR_PRM_ID_BIRTHYEAR) {
		param_value = (void *)Wbrp_pvalue.birth_year;
	}
	else if (param_id == WBR_PRM_ID_DISPTOTAL) {
		param_value = (void *)Wbrp_pvalue.disp_total;
	}
	else if (param_id == WBR_PRM_ID_CALENDAR) {
		param_value = (void *)Wbrp_pvalue.calendar;
	}

	else if (param_id == WBR_PRM_ID_GRAPHPOINT) {
		param_value = (void *)Wbrp_pvalue.graph_point;
	}
	else if (param_id == WBR_PRM_ID_GRAPHWIDTH) {
		param_value = (void *)Wbrp_pvalue.graph_width;
	}
	else if (param_id == WBR_PRM_ID_GRAPHHEIGHT) {
		param_value = (void *)Wbrp_pvalue.graph_height;
	}
	else if (param_id == WBR_PRM_ID_LINEWIDTH) {
		param_value = (void *)Wbrp_pvalue.line_width;
	}
	else if (param_id == WBR_PRM_ID_GRAPHDISP) {
		param_value = (void *)Wbrp_pvalue.graph_disp;
	}
	else if (param_id == WBR_PRM_ID_DAYLINE) {
		param_value = (void *)Wbrp_pvalue.day_line;
	}
	else if (param_id == WBR_PRM_ID_GRAPHFORE) {
		param_value = (void *)&Wbrp_pvalue.graph_color[0];
	}
	else if (param_id == WBR_PRM_ID_GRAPHBACK) {
		param_value = (void *)&Wbrp_pvalue.graph_color[1];
	}
	else if (param_id == WBR_PRM_ID_GRAPHPHYS) {
		param_value = (void *)&Wbrp_pvalue.graph_color[2];
	}
	else if (param_id == WBR_PRM_ID_GRAPHSENS) {
		param_value = (void *)&Wbrp_pvalue.graph_color[3];
	}
	else if (param_id == WBR_PRM_ID_GRAPHINTEL) {
		param_value = (void *)&Wbrp_pvalue.graph_color[4];
	}

	else if (param_id == WBR_PRM_ID_DISPDAY) {
		param_value = (void *)Wbrp_pvalue.disp_day;
	}

	return param_value;
}

/*===============
 *   ̾ : wbr_put_param()
 *     ǽ : ѥ᡼ͤΥå
 *    : ʤ
 */
void				wbr_put_param(
gint				param_id,			// (I) ѥ᡼ɣ
void				*param_value		// (I) ѥ᡼
)
{
	if (param_id == WBR_PRM_ID_DISPPERIOD) {
		Wbrp_pvalue.disp_period = (gint)param_value;
	}
	else if (param_id == WBR_PRM_ID_BIRTHYEAR) {
		Wbrp_pvalue.birth_year = (gboolean)param_value;
	}
	else if (param_id == WBR_PRM_ID_DISPTOTAL) {
		Wbrp_pvalue.disp_total = (gboolean)param_value;
	}
	else if (param_id == WBR_PRM_ID_CALENDAR) {
		Wbrp_pvalue.calendar = (gint)param_value;
	}

	else if (param_id == WBR_PRM_ID_GRAPHPOINT) {
		Wbrp_pvalue.graph_point = (gint)param_value;
	}
	else if (param_id == WBR_PRM_ID_GRAPHWIDTH) {
		Wbrp_pvalue.graph_width = (gint)param_value;
	}
	else if (param_id == WBR_PRM_ID_GRAPHHEIGHT) {
		Wbrp_pvalue.graph_height = (gint)param_value;
	}
	else if (param_id == WBR_PRM_ID_LINEWIDTH) {
		Wbrp_pvalue.line_width = (gint)param_value;
	}
	else if (param_id == WBR_PRM_ID_GRAPHDISP) {
		Wbrp_pvalue.graph_disp = (gint)param_value;
	}
	else if (param_id == WBR_PRM_ID_DAYLINE) {
		Wbrp_pvalue.day_line = (gboolean)param_value;
	}
	else if (param_id == WBR_PRM_ID_GRAPHFORE) {
		memcpy(&Wbrp_pvalue.graph_color[0],
				param_value, sizeof(GdkColor));
	}
	else if (param_id == WBR_PRM_ID_GRAPHBACK) {
		memcpy(&Wbrp_pvalue.graph_color[1],
				param_value, sizeof(GdkColor));
	}
	else if (param_id == WBR_PRM_ID_GRAPHPHYS) {
		memcpy(&Wbrp_pvalue.graph_color[2],
				param_value, sizeof(GdkColor));
	}
	else if (param_id == WBR_PRM_ID_GRAPHSENS) {
		memcpy(&Wbrp_pvalue.graph_color[3],
				param_value, sizeof(GdkColor));
	}
	else if (param_id == WBR_PRM_ID_GRAPHINTEL) {
		memcpy(&Wbrp_pvalue.graph_color[4],
				param_value, sizeof(GdkColor));
	}

	else if (param_id == WBR_PRM_ID_DISPDAY) {
		Wbrp_pvalue.disp_day = (time_t)param_value;
	}
}

/*===============
 *   ̾ : wbr_init_user_info()
 *     ǽ : ̾ν
 *    : ʤ
 */
void				wbr_init_user_info(void)
{
	int				loop_cnt;			// 롼ץ

	for (loop_cnt = 0; loop_cnt < Wbrp_pvalue.birth_num; loop_cnt++) {
		g_free(Wbrp_pvalue.user_name[loop_cnt]);
		Wbrp_pvalue.user_name[loop_cnt] = NULL;
	}
	g_free(Wbrp_pvalue.user_name);
	Wbrp_pvalue.user_name = NULL;

	g_free(Wbrp_pvalue.birthday);
	Wbrp_pvalue.birthday = NULL;

	Wbrp_pvalue.birth_num = 0;
}

/*===============
 *   ̾ : wbr_get_user_info()
 *     ǽ : ̾μ
 *    : ̾
 */
void				*wbr_get_user_info(
gint				param_id,			// (I) ѥ᡼ɣ
gint				birth_num			// (I) ֹ̾
)
{
	void			*param_value = NULL;// ѥ᡼

	if (param_id == WBR_PRM_ID_USERNAME) {
		if (Wbrp_pvalue.birth_num > 0) {
			param_value = (void *)Wbrp_pvalue.user_name[birth_num];
		}
	}
	else if (param_id == WBR_PRM_ID_BIRTHDAY) {
		if (Wbrp_pvalue.birth_num > 0) {
			param_value = (void *)Wbrp_pvalue.birthday[birth_num];
		}
	}
	else if (param_id == WBR_PRM_ID_BIRTHNUM) {
		param_value = (void *)Wbrp_pvalue.birth_num;
	}

	return param_value;
}

/*===============
 *   ̾ : wbr_put_user_info()
 *     ǽ : ̾
 *    : ʤ
 */
void				wbr_put_user_info(
gchar				*user_name,			// (I) ̾
time_t				birth_day			// (I) 
)
{
	Wbrp_pvalue.birth_num++;

	Wbrp_pvalue.user_name = g_realloc(Wbrp_pvalue.user_name,
									Wbrp_pvalue.birth_num);
	Wbrp_pvalue.user_name[Wbrp_pvalue.birth_num - 1]
					= g_malloc0(strlen(user_name) + 1);
	strcpy(Wbrp_pvalue.user_name[Wbrp_pvalue.birth_num - 1], user_name);

	Wbrp_pvalue.birthday = g_realloc(Wbrp_pvalue.birthday,
							sizeof(time_t) * Wbrp_pvalue.birth_num);
	Wbrp_pvalue.birthday[Wbrp_pvalue.birth_num - 1] = birth_day;
}

/*===============
 *   ̾ : wbr_read_inifile()
 *     ǽ : եɤ߹
 *    : TRUE= ｪλ, FALSE= եʤʤ
 */
gint				wbr_read_inifile(void)
{
	GdkColor		wbrp_def_color[] = {
						WBRP_PRM_DEF_GRAPHFORE,
						WBRP_PRM_DEF_GRAPHBACK,
						WBRP_PRM_DEF_GRAPHPHYS,
						WBRP_PRM_DEF_GRAPHSENS,
						WBRP_PRM_DEF_GRAPHINTEL
					};
	gint			ret_code = TRUE;	// 
	gchar			fname[MAXPATHLEN];	// ե̾
	gchar			key_str[100];		// 
	gchar			key_value[100];		// 
	FILE			*infp;				// եݥ

	memset(&Wbrp_pvalue, 0, sizeof(WBRP_PVALUE));
	Wbrp_pvalue.disp_period = WBRP_PRM_DEF_DISPPERIOD;
	Wbrp_pvalue.birth_year = TRUE;
	Wbrp_pvalue.disp_total = TRUE;
	Wbrp_pvalue.calendar = WBRP_PRM_DEF_CALENDAR;

	Wbrp_pvalue.graph_point = WBRP_PRM_DEF_GRAPHPOINT;
	Wbrp_pvalue.graph_width = 250;
	Wbrp_pvalue.graph_height = 200;
	Wbrp_pvalue.line_width = WBRP_PRM_DEF_LINEWIDTH;
	Wbrp_pvalue.graph_disp = WBRP_PRM_DEF_GRAPHDISP;
	Wbrp_pvalue.day_line = TRUE;
	memcpy(Wbrp_pvalue.graph_color,
		wbrp_def_color, sizeof(Wbrp_pvalue.graph_color));

	Wbrp_pvalue.disp_day = time(NULL);

	strcpy(fname, WBR_INIFILE);
	infp = fopen(fname, "r");
	if (infp) {
		while (wbrp_get_key_value(key_str, key_value, infp) == TRUE) {
			if (!strcmp(key_str, WBR_PRM_KEY_BIRTHDAY)) {
				wbrp_put_birthday(key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_DISPPERIOD)) {
				Wbrp_pvalue.disp_period = atoi(key_value);
				if ((Wbrp_pvalue.disp_period < 0)
					|| (Wbrp_pvalue.disp_period > 999)) {
					Wbrp_pvalue.disp_period = WBRP_PRM_DEF_DISPPERIOD;
				}
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_BIRTHYEAR)) {
				Wbrp_pvalue.birth_year = (gboolean)atoi(key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_DISPTOTAL)) {
				Wbrp_pvalue.disp_total = (gboolean)atoi(key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_CALENDAR)) {
				Wbrp_pvalue.calendar = atoi(key_value);
				if ((Wbrp_pvalue.calendar < 0)
					|| (Wbrp_pvalue.calendar > 4)) {
					Wbrp_pvalue.calendar = WBRP_PRM_DEF_CALENDAR;
				}
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHPOINT)) {
				Wbrp_pvalue.graph_point = atoi(key_value);
				if ((Wbrp_pvalue.graph_point < 0)
					|| (Wbrp_pvalue.graph_point > WBR_INTERVAL)) {
					Wbrp_pvalue.graph_point = WBRP_PRM_DEF_GRAPHPOINT;
				}
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHWIDTH)) {
				Wbrp_pvalue.graph_width = atoi(key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHHEIGHT)) {
				Wbrp_pvalue.graph_height = atoi(key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_LINEWIDTH)) {
				Wbrp_pvalue.line_width = atoi(key_value);
				if ((Wbrp_pvalue.line_width < 0)
					|| (Wbrp_pvalue.line_width > 5)) {
					Wbrp_pvalue.line_width = WBRP_PRM_DEF_LINEWIDTH;
				}
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHDISP)) {
				Wbrp_pvalue.graph_disp = atoi(key_value);
				if ((Wbrp_pvalue.graph_disp < 0)
					|| (Wbrp_pvalue.graph_disp
						> WBRP_PRM_DEF_GRAPHDISP)) {
					Wbrp_pvalue.graph_disp = WBRP_PRM_DEF_GRAPHDISP;
				}
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_DAYLINE)) {
				Wbrp_pvalue.day_line = (gboolean)atoi(key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHFORE)) {
				wbrp_get_color(&Wbrp_pvalue.graph_color[0], key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHBACK)) {
				wbrp_get_color(&Wbrp_pvalue.graph_color[1], key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHPHYS)) {
				wbrp_get_color(&Wbrp_pvalue.graph_color[2], key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHSENS)) {
				wbrp_get_color(&Wbrp_pvalue.graph_color[3], key_value);
			}
			else if (!strcmp(key_str, WBR_PRM_KEY_GRAPHINTEL)) {
				wbrp_get_color(&Wbrp_pvalue.graph_color[4], key_value);
			}
		}
		fclose(infp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : wbr_write_inifile()
 *     ǽ : եν񤭹
 *    : TRUE= ｪλ, FALSE= եʤʤ
 */
gint				wbr_write_inifile(void)
{
	gint			ret_code = TRUE;	// 
	gint			loop_cnt;			// 롼ץ
	gchar			fname[MAXPATHLEN];	// ե̾
	FILE			*outfp;				// եݥ

	strcpy(fname, WBR_INIFILE);
	outfp = fopen(fname, "w");
	if (outfp) {
		for (loop_cnt = 0;
			loop_cnt < Wbrp_pvalue.birth_num; loop_cnt++) {
			fprintf(outfp, "%s = %ld, %s\n",
					WBR_PRM_KEY_BIRTHDAY,
					Wbrp_pvalue.birthday[loop_cnt],
					Wbrp_pvalue.user_name[loop_cnt]);
		}
		if (Wbrp_pvalue.disp_period != WBRP_PRM_DEF_DISPPERIOD) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_DISPPERIOD, Wbrp_pvalue.disp_period);
		}
		if (Wbrp_pvalue.birth_year != TRUE) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_BIRTHYEAR, Wbrp_pvalue.birth_year);
		}
		if (Wbrp_pvalue.disp_total != TRUE) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_DISPTOTAL, Wbrp_pvalue.disp_total);
		}
		if (Wbrp_pvalue.calendar != WBRP_PRM_DEF_CALENDAR) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_CALENDAR, Wbrp_pvalue.calendar);
		}
		if (Wbrp_pvalue.graph_point != WBRP_PRM_DEF_GRAPHPOINT) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_GRAPHPOINT, Wbrp_pvalue.graph_point);
		}
#if 0
		fprintf(outfp, "%s = %d\n",
			WBR_PRM_KEY_GRAPHWIDTH, Wbrp_pvalue.graph_width);
		fprintf(outfp, "%s = %d\n",
			WBR_PRM_KEY_GRAPHHEIGHT, Wbrp_pvalue.graph_height);
#endif
		if (Wbrp_pvalue.line_width != WBRP_PRM_DEF_LINEWIDTH) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_LINEWIDTH, Wbrp_pvalue.line_width);
		}
		if (Wbrp_pvalue.graph_disp != WBRP_PRM_DEF_GRAPHDISP) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_GRAPHDISP, Wbrp_pvalue.graph_disp);
		}
		if (Wbrp_pvalue.day_line != TRUE) {
			fprintf(outfp, "%s = %d\n",
				WBR_PRM_KEY_DAYLINE, Wbrp_pvalue.day_line);
		}
		fprintf(outfp, "%s = %ld, %d, %d, %d\n",
			WBR_PRM_KEY_GRAPHFORE,
			Wbrp_pvalue.graph_color[0].pixel,
			Wbrp_pvalue.graph_color[0].red,
			Wbrp_pvalue.graph_color[0].green,
			Wbrp_pvalue.graph_color[0].blue);
		fprintf(outfp, "%s = %ld, %d, %d, %d\n",
			WBR_PRM_KEY_GRAPHBACK,
			Wbrp_pvalue.graph_color[1].pixel,
			Wbrp_pvalue.graph_color[1].red,
			Wbrp_pvalue.graph_color[1].green,
			Wbrp_pvalue.graph_color[1].blue);
		fprintf(outfp, "%s = %ld, %d, %d, %d\n",
			WBR_PRM_KEY_GRAPHPHYS,
			Wbrp_pvalue.graph_color[2].pixel,
			Wbrp_pvalue.graph_color[2].red,
			Wbrp_pvalue.graph_color[2].green,
			Wbrp_pvalue.graph_color[2].blue);
		fprintf(outfp, "%s = %ld, %d, %d, %d\n",
			WBR_PRM_KEY_GRAPHSENS,
			Wbrp_pvalue.graph_color[3].pixel,
			Wbrp_pvalue.graph_color[3].red,
			Wbrp_pvalue.graph_color[3].green,
			Wbrp_pvalue.graph_color[3].blue);
		fprintf(outfp, "%s = %ld, %d, %d, %d\n",
			WBR_PRM_KEY_GRAPHINTEL,
			Wbrp_pvalue.graph_color[4].pixel,
			Wbrp_pvalue.graph_color[4].red,
			Wbrp_pvalue.graph_color[4].green,
			Wbrp_pvalue.graph_color[4].blue);

		fclose(outfp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : wbrp_get_key_value()
 *     ǽ : ɤͤɤ߹
 *    : TRUE= ｪλ, FALSE= ե뽪üʤ
 */
static gboolean		wbrp_get_key_value(
gchar				*key_str,			// ( O ) 
gchar				*key_value,			// ( O ) 
FILE				*read_fp			// (I/O) եݥ
)
{
	gboolean		ret_code = FALSE;	// 
	gchar			read_buff[100];		// ɤ߹ߥХåե
	gchar			*buff_ptr;			//
	gchar			*equal_pos;			// ΰ

	while ((ret_code == FALSE)
		&& (fgets(read_buff, sizeof(read_buff), read_fp))) {

		buff_ptr = read_buff;
		wbr_trim(buff_ptr);
		if (*buff_ptr != '#') {
			equal_pos = strchr(buff_ptr, '=');
			if (equal_pos) {
				strcpy(key_value, (equal_pos + 1));
				strncpy(key_str, buff_ptr, (equal_pos - buff_ptr));
				*(key_str + (equal_pos - buff_ptr)) = '\0';
				wbr_trim(key_str);
				while (*key_str) {
					*key_str = tolower(*key_str);
					key_str++;
				}
				wbr_trim(key_value);
				ret_code = TRUE;
			}
		}
	}

	return ret_code;
}

/*===============
 *   ̾ : wbrp_put_birthday()
 *     ǽ : ̾
 *    : ʤ
 */
static void			wbrp_put_birthday(
gchar				*values				// (I) 
)
{
	gchar			*user_name;			// ̾
	time_t			birthday;			// 

	birthday = atoi(values);
	user_name = strchr(values, ',');
	if (user_name == NULL) {
		user_name = "̾ʤ";
	}
	else {
		user_name++;
		wbr_trim(user_name);
	}

	wbr_put_user_info(user_name, birthday);
}

/*===============
 *   ̾ : wbrp_get_color()
 *     ǽ : μ
 *    : ʤ
 */
static void			wbrp_get_color(
GdkColor			*graph_color,		// (O) 
gchar				*values				// (I) 
)
{
	gulong			pixel;				// ԥ
	gushort			red = 0;			// 
	gushort			green = 0;			// 
	gushort			blue = 0;			// 
	gchar			*val_ptr;			//

	pixel = atoi(values);
	val_ptr = strchr(values, ',');
	if (val_ptr != NULL) {
		val_ptr++;
		red = atoi(val_ptr);
		val_ptr = strchr(val_ptr, ',');
		if (val_ptr != NULL) {
			val_ptr++;
			green = atoi(val_ptr);
			val_ptr = strchr(val_ptr, ',');
			if (val_ptr != NULL) {
				val_ptr++;
				blue = atoi(val_ptr);
			}
		}
	}

	graph_color->pixel = pixel;
	graph_color->red = red;
	graph_color->green = green;
	graph_color->blue = blue;
}
